Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMClustering.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMClustering.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMClustering.cs	(revision 16899)
@@ -22,5 +22,4 @@
 using HeuristicLab.Core;
 using System.Collections.Generic;
-using System.Linq;
 
 namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
@@ -40,26 +39,5 @@
       return K;
     }
-    public static void ApplyFullConectedMapCreationAlgorithm(IRandom random, double[,] distances, List<List<int>> map, int k, int neghboorNumber = 10) {
-      int mapSize = distances.GetLength(0);
-      List<double> currentList = new List<double>();
-      for (int i = 0; i < mapSize; i++) {
-        map.Add(new List<int>());
-        for (int j = 0; j < mapSize; j++) {
-          currentList.Add(distances[i, j]);
-        }
-        map[i].Add(ChooseMinElement(currentList));
-        while (map[i].Count < neghboorNumber) {
-          map[i].Add(ChooseMinElement(currentList, i, map[i]));
-        }
-        currentList.Clear();
-      }
-    }
-    private static bool CheckNumberIsInList(int number, List<int> priviousNumber) {
-      foreach (var pNum in priviousNumber) {
-        if (number == pNum)
-          return true;
-      }
-      return false;
-    }
+
     public static int ApplyClusteringAlgorithm(IRandom random, double[,] distances, List<int> numberCluster, int k) {
       int mapSize = distances.GetLength(0);
@@ -82,5 +60,5 @@
         }
         for (int i = 0; i < mapSize; i++) {
-          numberCluster[i] = LookCloseCentroid(centroids, mapSize, distances, i, k);
+          numberCluster[i] = LookCloseCentroid(centroids, distances, i, k);
           clusters[numberCluster[i]].Add(numberCluster[i]);
         }
@@ -89,5 +67,5 @@
         for (int i = 0; i < k; i++) {
           AverageClusterDistanceCalculation(averageClusterDistance, distances, numberCluster, mapSize, i);
-          var newCentroid = clusters[i][ChooseMinElement(averageClusterDistance)];
+          var newCentroid = clusters[i][HelpFunctions.ChooseMinElementIndex(averageClusterDistance)];
           if (newCentroid != centroids[i]) {
             flag = true;
@@ -104,5 +82,5 @@
       }
     }
-    private static int LookCloseCentroid(List<int> centroids, int MapSize, double[,] distances, int currentNumber, int k) {
+    private static int LookCloseCentroid(List<int> centroids, double[,] distances, int currentNumber, int k) {
       double minDistanse = distances[currentNumber, centroids[0]];
       int clusterNum = 0;
@@ -152,35 +130,6 @@
       }
     }
-    private static int ChooseMinElement(List<double> averageClusterDistance) {
-      double minValue = averageClusterDistance[0];
-      int minElementNumber = 0;
-      for (int i = 1; i < averageClusterDistance.Count(); i++) {
-        if (averageClusterDistance[i] < minValue) {
-          minValue = averageClusterDistance[i];
-          minElementNumber = i;
-        }
-      }
-      return minElementNumber;
-    }
-    private static int ChooseMinElement(List<double> distances, int currentElement, List<int> previousNumbers) {
-      double minValue = 100;
-      int minElementNumber = 0;
-      int temp = 0, i = 0;
-      while (temp == 0) {
-        if ((currentElement != i) && (!CheckNumberIsInList(i, previousNumbers))) {
-          minValue = distances[i];
-          minElementNumber = i;
-          temp = i;
-        }
-        i++;
-      }
-      for (i = 0; i < distances.Count(); i++) {
-        if ((distances[i] < minValue) && (currentElement != i) && (!CheckNumberIsInList(i, previousNumbers))) {
-          minValue = distances[i];
-          minElementNumber = i;
-        }
-      }
-      return minElementNumber;
-    }
+
+
   }
 }
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMDisatanceMap.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMDisatanceMap.cs	(revision 16899)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMDisatanceMap.cs	(revision 16899)
@@ -0,0 +1,52 @@
+﻿using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
+  [Item("DistanceMap", "A map of models of models of models")]
+  [StorableType("456692FB-2149-4359-8106-45D59D2D7FA0")]
+  public class EMMDisatanceMap : EMMMapBase<ISymbolicExpressionTree> {
+
+    // Under the work now. Do not take into account =)
+    #region conctructors
+    [StorableConstructor]
+    protected EMMDisatanceMap(StorableConstructorFlag _) : base(_) { }
+    public EMMDisatanceMap() : this(1) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EMMDisatanceMap(this, cloner);
+    }
+    public EMMDisatanceMap(int k) : base(k) { ModelSet = new List<ISymbolicExpressionTree>(); }
+    public EMMDisatanceMap(EMMDisatanceMap original, Cloner cloner) : base(original, cloner) { }
+    #endregion
+    #region MapApplayFunctions
+    override public void CreateMap(IRandom random, int k) {
+      K = Map.Count;
+      ApplyDistanceMapCreationAlgorithm(random, Distances, Map, K);
+      for (int i = 0; i < Map.Count; i++) {
+        ClusterNumber.Add(i);
+      }
+    }
+    public static void ApplyDistanceMapCreationAlgorithm(IRandom random, double[,] distances, List<List<int>> map, int k, int neghboorNumber = 10) {
+      int mapSize = distances.GetLength(0);
+      List<double> currentList = new List<double>();
+      for (int i = 0; i < mapSize; i++) {
+        map.Add(new List<int>());
+        for (int j = 0; j < mapSize; j++) {
+          currentList.Add(distances[i, j]);
+        }
+        map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList));
+        while (map[i].Count < neghboorNumber) {
+          map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList, i, map[i]));
+        }
+        currentList.Clear();
+      }
+    }
+
+    override public ISymbolicExpressionTree NewModelForInizializtionNotTree(IRandom random, out int cluster, out int treeNumber) {
+      return NewModelForInizializtion(random, out cluster, out treeNumber);
+    }
+    #endregion
+  }
+}
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMIslandMap.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMIslandMap.cs	(revision 16899)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMIslandMap.cs	(revision 16899)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
+  [Item("IslandMap", "A map of models of models of models")]
+  [StorableType("E4AB04B9-FD5D-47EE-949D-243660754F3A")]
+  public class EMMIslandMap : EMMMapBase<ISymbolicExpressionTree> {
+    #region conctructors
+    [StorableConstructor]
+    protected EMMIslandMap(StorableConstructorFlag _) : base(_) { }
+    public EMMIslandMap() : this(1) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EMMIslandMap(this, cloner);
+    }
+    public EMMIslandMap(int k) : base(k) { ModelSet = new List<ISymbolicExpressionTree>(); }
+    public EMMIslandMap(EMMIslandMap original, Cloner cloner) : base(original, cloner) { }
+    // public EMMIslandMap(IRandom random, IEnumerable<ISymbolicExpressionTree> trees, int k, int neghboorNumber) : base(random, trees, k) { }
+    //public EMMIslandMap(IRandom random, IEnumerable<ISymbolicExpressionTree> trees, string fileName = "Map.txt") : base(random, trees, fileName) { }
+    #endregion
+    #region MapApplayFunctions
+    override public void CreateMap(IRandom random, int k) {
+      K = EMModelsClusterizationAlgorithm.ApplyClusteringAlgorithm(random, Distances, ClusterNumber, k);
+      MapSizeCheck();
+      for (int i = 0; i < ModelSet.Count; i++) {
+        Map[ClusterNumber[i]].Add(i);
+      }
+    }
+    override public ISymbolicExpressionTree NewModelForInizializtionNotTree(IRandom random, out int cluster, out int treeNumber) {
+      return NewModelForInizializtion(random, out cluster, out treeNumber);
+    }
+    #endregion
+
+  }
+}
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutator.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutator.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutator.cs	(revision 16899)
@@ -35,24 +35,15 @@
   [StorableType("918B5F77-3B9E-4620-94A3-236913C4A3F2")]
   public sealed class EMMMultyPointsMutator : SymbolicExpressionTreeManipulator {
-    private const string ModelSetParameterName = "Models";
-    private const string ClusterNumberParameterName = "ClusterNumber";
     private const string MapParameterName = "Map";
     private const string MutationProbabilityParameterName = "MutationProbability";
-    public ILookupParameter<ItemList<ISymbolicExpressionTree>> ModelSetParameter {
-      get { return (ILookupParameter<ItemList<ISymbolicExpressionTree>>)Parameters[ModelSetParameterName]; }
-    }
-    public ILookupParameter<ItemList<IntValue>> ClusterNumberParameter {
-      get { return (ILookupParameter<ItemList<IntValue>>)Parameters[ClusterNumberParameterName]; }
-    }
-
-    public ILookupParameter<ItemList<ItemList<IntValue>>> MapParameter {
-      get { return (ILookupParameter<ItemList<ItemList<IntValue>>>)Parameters[MapParameterName]; }
+    public ILookupParameter<EMMMapBase<ISymbolicExpressionTree>> MapParameter {
+      get { return (ILookupParameter<EMMMapBase<ISymbolicExpressionTree>>)Parameters[MapParameterName]; }
     }
     public ILookupParameter<PercentValue> MutationProbabilityParameter {
       get { return (ILookupParameter<PercentValue>)Parameters[MutationProbabilityParameterName]; }
     }
-    public ItemList<ISymbolicExpressionTree> ModelSet => ModelSetParameter.ActualValue;
-    public ItemList<IntValue> ClusterNumber => ClusterNumberParameter.ActualValue;
-    public ItemList<ItemList<IntValue>> Map => MapParameter.ActualValue;
+    public List<ISymbolicExpressionTree> ModelSet => MapParameter.ActualValue.ModelSet;
+    public List<int> ClusterNumber => MapParameter.ActualValue.ClusterNumber;
+    public List<List<int>> Map => MapParameter.ActualValue.Map;
     public PercentValue MutationProbability => MutationProbabilityParameter.ActualValue;
 
@@ -61,7 +52,5 @@
     private EMMMultyPointsMutator(EMMMultyPointsMutator original, Cloner cloner) : base(original, cloner) { }
     public EMMMultyPointsMutator() : base() {
-      Parameters.Add(new LookupParameter<ItemList<ISymbolicExpressionTree>>(ModelSetParameterName));
-      Parameters.Add(new LookupParameter<ItemList<IntValue>>(ClusterNumberParameterName));
-      Parameters.Add(new LookupParameter<ItemList<ItemList<IntValue>>>(MapParameterName));
+      Parameters.Add(new LookupParameter<EMMMapBase<ISymbolicExpressionTree>>(MapParameterName));
       Parameters.Add(new LookupParameter<PercentValue>(MutationProbabilityParameterName));
     }
@@ -81,5 +70,5 @@
       return false;
     }
-    public static void EMMOnePointMutatorPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, ItemList<ISymbolicExpressionTree> modelSet, ItemList<IntValue> clusterNumber, ItemList<ItemList<IntValue>> map, PercentValue mutationProbability) {
+    public static void EMMOnePointMutatorPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, List<ISymbolicExpressionTree> modelSet, List<int> clusterNumber, List<List<int>> map, PercentValue mutationProbability) {
 
       List<ISymbol> allowedSymbols = new List<ISymbol>();
@@ -113,5 +102,5 @@
 
             if (node is TreeModelTreeNode treeNode2) { // make rigth mutation for tree model
-              treeNode2.TreeNumber = map[pTemp].SampleRandom(random).Value;
+              treeNode2.TreeNumber = map[pTemp].SampleRandom(random);
               treeNode2.Tree = (ISymbolicExpressionTree)modelSet[treeNode2.TreeNumber].Clone();
               treeNode2.ClusterNumer = pTemp;
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutatorNodeTypeSaving.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutatorNodeTypeSaving.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMultyPointsMutatorNodeTypeSaving.cs	(revision 16899)
@@ -35,24 +35,18 @@
   [StorableType("8A24C715-BEFD-4396-9264-31F949330B1A")]
   public sealed class EMMMultyPointsMutatorNodeTypeSaving : SymbolicExpressionTreeManipulator {
-    private const string ModelSetParameterName = "Models";
-    private const string ClusterNumberParameterName = "ClusterNumber";
+
     private const string MapParameterName = "Map";
     private const string MutationProbabilityParameterName = "MutationProbability";
-    public ILookupParameter<ItemList<ISymbolicExpressionTree>> ModelSetParameter {
-      get { return (ILookupParameter<ItemList<ISymbolicExpressionTree>>)Parameters[ModelSetParameterName]; }
+    public ILookupParameter<EMMMapBase<ISymbolicExpressionTree>> MapParameter {
+      get { return (ILookupParameter<EMMMapBase<ISymbolicExpressionTree>>)Parameters[MapParameterName]; }
     }
-    public ILookupParameter<ItemList<IntValue>> ClusterNumberParameter {
-      get { return (ILookupParameter<ItemList<IntValue>>)Parameters[ClusterNumberParameterName]; }
-    }
+    public List<ISymbolicExpressionTree> ModelSet => MapParameter.ActualValue.ModelSet;
+    public List<int> ClusterNumber => MapParameter.ActualValue.ClusterNumber;
+    public List<List<int>> Map => MapParameter.ActualValue.Map;
 
-    public ILookupParameter<ItemList<ItemList<IntValue>>> MapParameter {
-      get { return (ILookupParameter<ItemList<ItemList<IntValue>>>)Parameters[MapParameterName]; }
-    }
     public ILookupParameter<PercentValue> MutationProbabilityParameter {
       get { return (ILookupParameter<PercentValue>)Parameters[MutationProbabilityParameterName]; }
     }
-    public ItemList<ISymbolicExpressionTree> ModelSet => ModelSetParameter.ActualValue;
-    public ItemList<IntValue> ClusterNumber => ClusterNumberParameter.ActualValue;
-    public ItemList<ItemList<IntValue>> Map => MapParameter.ActualValue;
+
     public PercentValue MutationProbability => MutationProbabilityParameter.ActualValue;
 
@@ -61,7 +55,5 @@
     private EMMMultyPointsMutatorNodeTypeSaving(EMMMultyPointsMutatorNodeTypeSaving original, Cloner cloner) : base(original, cloner) { }
     public EMMMultyPointsMutatorNodeTypeSaving() : base() {
-      Parameters.Add(new LookupParameter<ItemList<ISymbolicExpressionTree>>(ModelSetParameterName));
-      Parameters.Add(new LookupParameter<ItemList<IntValue>>(ClusterNumberParameterName));
-      Parameters.Add(new LookupParameter<ItemList<ItemList<IntValue>>>(MapParameterName));
+      Parameters.Add(new LookupParameter<EMMMapBase<ISymbolicExpressionTree>>(MapParameterName));
       Parameters.Add(new LookupParameter<PercentValue>(MutationProbabilityParameterName));
     }
@@ -81,5 +73,5 @@
       return false;
     }
-    public static void EMMOnePointMutatorPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, ItemList<ISymbolicExpressionTree> modelSet, ItemList<IntValue> clusterNumber, ItemList<ItemList<IntValue>> map, PercentValue mutationProbability) {
+    public static void EMMOnePointMutatorPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, List<ISymbolicExpressionTree> modelSet, List<int> clusterNumber, List<List<int>> map, PercentValue mutationProbability) {
 
       List<ISymbol> allowedSymbols = new List<ISymbol>();
@@ -113,5 +105,5 @@
 
             if (node is TreeModelTreeNode treeNode2) { // make rigth mutation for tree model
-              treeNode2.TreeNumber = map[pTemp].SampleRandom(random).Value;
+              treeNode2.TreeNumber = map[pTemp].SampleRandom(random);
               treeNode2.Tree = (ISymbolicExpressionTree)modelSet[treeNode2.TreeNumber].Clone();
               treeNode2.ClusterNumer = pTemp;
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMutators.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMutators.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMMutators.cs	(revision 16899)
@@ -36,24 +36,13 @@
   public sealed class EMMMutators : SymbolicExpressionTreeManipulator {
     private const int MAX_TRIES = 100;
-
-    private const string ModelSetParameterName = "Models";
-    private const string ClusterNumberParameterName = "ClusterNumber";
     private const string MapParameterName = "Map";
 
-    public ILookupParameter<ItemList<ISymbolicExpressionTree>> ModelSetParameter {
-      get { return (ILookupParameter<ItemList<ISymbolicExpressionTree>>)Parameters[ModelSetParameterName]; }
+    public ILookupParameter<EMMMapBase<ISymbolicExpressionTree>> MapParameter {
+      get { return (ILookupParameter<EMMMapBase<ISymbolicExpressionTree>>)Parameters[MapParameterName]; }
     }
 
-    public ILookupParameter<ItemList<IntValue>> ClusterNumberParameter {
-      get { return (ILookupParameter<ItemList<IntValue>>)Parameters[ClusterNumberParameterName]; }
-    }
-
-    public ILookupParameter<ItemList<ItemList<IntValue>>> MapParameter {
-      get { return (ILookupParameter<ItemList<ItemList<IntValue>>>)Parameters[MapParameterName]; }
-    }
-
-    public ItemList<ISymbolicExpressionTree> ModelSet => ModelSetParameter.ActualValue;
-    public ItemList<IntValue> ClusterNumber => ClusterNumberParameter.ActualValue;
-    public ItemList<ItemList<IntValue>> Map => MapParameter.ActualValue;
+    public List<ISymbolicExpressionTree> ModelSet => MapParameter.ActualValue.ModelSet;
+    public List<int> ClusterNumber => MapParameter.ActualValue.ClusterNumber;
+    public List<List<int>> Map => MapParameter.ActualValue.Map;
 
     [StorableConstructor]
@@ -61,7 +50,5 @@
     private EMMMutators(EMMMutators original, Cloner cloner) : base(original, cloner) { }
     public EMMMutators() : base() {
-      Parameters.Add(new LookupParameter<ItemList<ISymbolicExpressionTree>>(ModelSetParameterName));
-      Parameters.Add(new LookupParameter<ItemList<IntValue>>(ClusterNumberParameterName));
-      Parameters.Add(new LookupParameter<ItemList<ItemList<IntValue>>>(MapParameterName));
+      Parameters.Add(new LookupParameter<EMMMapBase<ISymbolicExpressionTree>>(MapParameterName));
     }
 
@@ -73,5 +60,5 @@
       EMMMutatorsPart(random, symbolicExpressionTree, ModelSet, ClusterNumber, Map);
     }
-    public static void EMMMutatorsPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, ItemList<ISymbolicExpressionTree> modelSet, ItemList<IntValue> clusterNumber, ItemList<ItemList<IntValue>> map) {
+    public static void EMMMutatorsPart(IRandom random, ISymbolicExpressionTree symbolicExpressionTree, List<ISymbolicExpressionTree> modelSet, List<int> clusterNumber, List<List<int>> map) {
       List<ISymbol> allowedSymbols = new List<ISymbol>();
       ISymbolicExpressionTreeNode parent;
@@ -124,5 +111,5 @@
           int p = random.Next(map.Count);
           if (child is TreeModelTreeNode chNode) { p = chNode.ClusterNumer; }
-          treeNode.TreeNumber = map[p].SampleRandom(random).Value;
+          treeNode.TreeNumber = map[p].SampleRandom(random);
           treeNode.Tree = (ISymbolicExpressionTree)modelSet[treeNode.TreeNumber].Clone();
           treeNode.ClusterNumer = p;
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMNetworkMap.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMNetworkMap.cs	(revision 16899)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/EMMNetworkMap.cs	(revision 16899)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
+  [Item("NetworkMap", "A map of models of models of models")]
+  [StorableType("C200ECC2-6D33-4468-A538-580B07D75B3C")]
+  public class EMMNetworkMap : EMMMapBase<ISymbolicExpressionTree> {
+    public int NeghboorNumber { get; set; }
+    #region conctructors
+    [StorableConstructor]
+    protected EMMNetworkMap(StorableConstructorFlag _) : base(_) { }
+    public EMMNetworkMap() : this(1) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EMMNetworkMap(this, cloner);
+    }
+    public EMMNetworkMap(int neghboorNumber = 10) : base() {
+      NeghboorNumber = neghboorNumber;
+    }
+    public EMMNetworkMap(EMMNetworkMap original, Cloner cloner) : base(original, cloner) { NeghboorNumber = original.NeghboorNumber; }
+    //public EMMNetworkMap(IRandom random, IEnumerable<ISymbolicExpressionTree> trees, int k, int neghboorNumber = 10) : this(neghboorNumber) {
+    //  // constructor that should be used in case of creation of a new map from the start point
+    //  ModelSet = trees.ToList();
+    //  CalculateDistances();
+    //  NeghboorNumber = neghboorNumber; // this shoud be done before map creation, so it is impossible to create tree wisout it
+    //  CreateMap(random, k);
+    //}
+    //public EMMNetworkMap(IRandom random, IEnumerable<ISymbolicExpressionTree> trees, string fileName = "Map.txt") : base(random, trees, fileName) {
+    //  NeghboorNumber = Map[0].Count;
+    //}
+    #endregion
+    #region MapTransformation
+    override public void CreateMap(IRandom random, int k) {
+      K = Map.Count;
+      ApplyNetworkMapCreationAlgorithm(random, Distances, Map, K, NeghboorNumber);
+      for (int i = 0; i < Map.Count; i++) {
+        ClusterNumber.Add(i);
+      }
+    }
+    public static void ApplyNetworkMapCreationAlgorithm(IRandom random, double[,] distances, List<List<int>> map, int k, int neghboorNumber = 10) {
+      int mapSize = distances.GetLength(0);
+      List<double> currentList = new List<double>();
+      for (int i = 0; i < mapSize; i++) {
+        map.Add(new List<int>());
+        for (int j = 0; j < mapSize; j++) {
+          currentList.Add(distances[i, j]);
+        }
+        map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList));
+        while (map[i].Count < neghboorNumber) {
+          map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList, i, map[i]));
+        }
+        currentList.Clear();
+      }
+    }
+    #endregion
+    #region Dialog with surroudings
+    override public ISymbolicExpressionTree NewModelForInizializtionNotTree(IRandom random, out int cluster, out int treeNumber) {
+      var newTree = NewModelForInizializtion(random, out cluster, out treeNumber);
+      return newTree;
+    }
+    #endregion
+  }
+}
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HelpFunctions.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HelpFunctions.cs	(revision 16899)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HelpFunctions.cs	(revision 16899)
@@ -0,0 +1,49 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
+  class HelpFunctions {
+    public static int ChooseMinElementIndex(List<double> distances, int currentElement, List<int> previousNumbers) {
+      double minValue = 100;
+      int minElementNumber = 0;
+      int temp = 0, i = 0;
+      while (temp == 0) {
+        if ((currentElement != i) && (!CheckNumberIsInList(i, previousNumbers))) {
+          minValue = distances[i];
+          minElementNumber = i;
+          temp = i;
+        }
+        i++;
+      }
+      for (i = 0; i < distances.Count(); i++) {
+        if ((distances[i] < minValue) && (currentElement != i) && (!CheckNumberIsInList(i, previousNumbers))) {
+          minValue = distances[i];
+          minElementNumber = i;
+        }
+      }
+      return minElementNumber;
+    }
+    public static bool CheckNumberIsInList(int number, List<int> priviousNumber) {
+      foreach (var pNum in priviousNumber) {
+        if (number == pNum)
+          return true;
+      }
+      return false;
+    }
+    public static int ChooseMinElementIndex(List<double> averageClusterDistance) {
+      double minValue = averageClusterDistance[0];
+      int minElementNumber = 0;
+      for (int i = 1; i < averageClusterDistance.Count(); i++) {
+        if (averageClusterDistance[i] < minValue) {
+          minValue = averageClusterDistance[i];
+          minElementNumber = i;
+        }
+      }
+      return minElementNumber;
+    }
+  }
+}
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HeuristicLab.Algorithms.EvolvmentModelsOfModels.csproj
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HeuristicLab.Algorithms.EvolvmentModelsOfModels.csproj	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/HeuristicLab.Algorithms.EvolvmentModelsOfModels.csproj	(revision 16899)
@@ -23,4 +23,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>7.1</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -31,4 +32,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <LangVersion>7.1</LangVersion>
   </PropertyGroup>
   <ItemGroup>
@@ -40,4 +42,9 @@
     <Reference Include="HeuristicLab.Analysis-3.3">
       <HintPath>..\..\..\trunk\bin\HeuristicLab.Analysis-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Attic, Version=1.0.0.0, Culture=neutral, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\bin\HeuristicLab.Attic.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -61,4 +68,5 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\trunk\bin\HeuristicLab.Operators-3.3.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.Optimization-3.3">
@@ -109,13 +117,16 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="EMMDisatanceMap.cs" />
     <Compile Include="EMMMultyPointsMutator.cs" />
     <Compile Include="EMMAlgorithm.cs" />
     <Compile Include="EMMClustering.cs" />
-    <Compile Include="EMMMapBase.cs" />
-    <Compile Include="EMMMapTreeModel.cs" />
+    <Compile Include="EMMBaseMap.cs" />
+    <Compile Include="EMMIslandMap.cs" />
     <Compile Include="EMMMultyPointsMutatorNodeTypeSaving.cs" />
     <Compile Include="EMMMutators.cs" />
     <Compile Include="EMMSolution.cs" />
     <Compile Include="EMMBaseAlgorithm.cs" />
+    <Compile Include="EMMNetworkMap.cs" />
+    <Compile Include="HelpFunctions.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/Plugin.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/Plugin.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Algorithms.EMM/Plugin.cs	(revision 16899)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.EMMAlgorithm plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.EMMAlgorithm", "3.3.15.16734")]
+  [Plugin("HeuristicLab.Algorithms.EMMAlgorithm", "3.3.15.16760")]
   [PluginFile("HeuristicLab.Algorithms.EMMAlgorithm-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: /branches/2988_ModelsOfModels2/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeGraphvizFormatter.cs
===================================================================
--- /branches/2988_ModelsOfModels2/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeGraphvizFormatter.cs	(revision 16898)
+++ /branches/2988_ModelsOfModels2/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeGraphvizFormatter.cs	(revision 16899)
@@ -33,5 +33,25 @@
       // match Koza style
       {"ProgramRootSymbol", "Prog"},
-      {"StartSymbol", "RPB"}, 
+      {"StartSymbol", "RPB"},
+
+      // short form 
+      {"Subtraction", "-" },
+      {"Addition", "+" },
+      {"Multiplication", "*" },
+      {"Division", "/" },
+      {"Absolute", "abs" },
+      {"AnalyticQuotient", "AQ" },
+      {"Sine", "sin" },
+      {"Cosine", "cos" },
+      {"Tanget", "tan" },
+      {"HyperbolicTangent", "tanh" },
+      {"Exponential", "exp" },
+      {"Logarithm", "log" },
+      {"SquareRoot", "sqrt" },
+      {"Square", "sqr" },
+      {"CubeRoot", "cbrt" },
+      {"Cube", "cube" },
+      {"GreaterThan", ">" },
+      {"LessThan", "<" },
     };
 
